                               (* BLOCKI.PAS *)

(* unit BlockI includes procedures for user interaction
   and screen display of units BLOCKMO and MULBLO. *)

unit BlockI;

interface

uses B_cons, WBlib, Forms;
(* B_cons contains constants. *)

const     nformax = 120;

var stopped: Boolean;
    nforform: integer;

procedure stopthis(s: string; var outf, outf1: textfile; outfn, outfn1: string);
procedure AttachProject(var outf, outf1: textfile;
                        var proname, outfn, outfn1: string);
procedure OptMessage1(sm: integer);
procedure OptMessage2(i: integer; i1,i2: real);
procedure OptMessage3(s: string);
procedure SayResults1;
procedure SayResults2;
procedure ShowWorking(c: string);
function Restart: boolean;
function escape: Boolean;
procedure DefineTitle(s: string);
procedure writescreen(c, cmi, cma, nrun: integer; iden, mult, conv: boolean;
                       multinum, multi: integer);
procedure ShowXE(i, nn: integer; var x: coloring; d: integer);

implementation

uses SysUtils, Dialogs, blocks_1;


procedure stopthis(s:string; var outf, outf1: textfile; outfn, outfn1: string);
begin
  writeln(outf1, 'Error : ');
  writeln(outf1, s);
  writeln(outf1, 'For a bit more information, consult the output file.');
  writeln(outf1);
  writeln(outf,'The program is terminated.');
  writeln(outf);
  stopped := true;
end; (* stopthis *)


procedure Outputfiles(var fn1, fn2: String; fn3: String; appendf: boolean;
     var f1, f2: textfile);
var  fn0: String; 
procedure OPF(fn: string; var f: textfile);
 begin
 assignfile(f,fn);
 rewrite(f);                        
 writeln(f,'                        ****************** ');
 writeln(f,'                         ',fn);
 writeln(f,'                        ****************** ');
 writeln(f);
 writeln(f);
 writeln(f,'Time: '+DateTimeToStr(Now));
 writeln(f); writeln(f);
 writeln(f); writeln(f);
end; (* OPF *)
begin
  fn0 := fn3+'.out';
  fn1 := fn0;
  fn1 := fn0;
  if (appendf and fileexists(fn1)) then begin
    assignfile(f1,fn1);
    append(f1);
    writeln(f1);
    writeln(f1,'@0');
    writeln(f1,'New run of BLOCKS');
    writeln(f1,'=================');
    writeln(f1);
   end else
    OPF(fn1,f1);

  fn2:=changefileext(fn1,'.PQR');
  OPF(fn2,f2);
  writeln(f2,'Secondary output file for some extra details; main output is in ',
              fn1,'.');
  writeln(f1,'Secondary output is on file ',fn2,';');
  writeln(f1,'file ',fn2,
   ' is overwritten in each run of BLOCKS with this project name!');
end;

procedure AttachProject(var outf, outf1: textfile;
                        var proname, outfn, outfn1: string);
var nopro,apf: boolean;
 infn: string;
 inf: textfile;
 i,dumm: integer;
begin
  proname:=ParamStr(1);
  if (proname = '') then begin
    proname:='current';
    nopro := true;
   end else nopro := false;

  infn := proname+'.in';
  if FileExists(infn) then begin
    assignfile(inf,infn);
    reset(inf);
    for i:=1 to 12 do readln(inf);
    readln(inf,dumm);
    apf := (dumm >= 1);
    closefile(inf);
   end else apf := true;
  outputfiles(outfn,outfn1,proname,apf,outf,outf1);
  if nopro then begin
    writeln(outf,'Warning: no project name was given,');
    writeln(outf,'the project name <<current>> is used as a default.');
   end;
  writeln(outf,'The input file specifies that, if there exists an earlier file named ',
             outfn,',');
  write(outf,'the following new output ');
  if apf then write(outf,'is appended to ')
   else write(outf,'overwrites ');
  writeln(outf,'the earlier existing file.');
end; (* AttachProject *)


procedure OptMessage3(s: string);
begin
 BlocksForm.LStatus.Caption := s;
 BlocksForm.Lstatus.Enabled := true;
 Application.ProcessMessages;
end;

procedure OptMessage1(sm: integer);
begin
  BlocksForm.LStatus.Caption:='Preliminary search for good starting values ('+
                               inttostr(sm)+' trials).';
  BlocksForm.BRestart.Enabled := False;
  Application.ProcessMessages;
end;

procedure OptMessage2(i: integer; i1,i2: real);
var s:string;
begin
  with BlocksForm do
  begin
    Literation.caption := 'number of partition  ';
    str(i:4,s); Iteration.Text:=s;
    str(i2:12:6,s); LMinimal.Caption:='minimal information up to now '+s;
  end;
 Application.ProcessMessages;
end;

function Restart: boolean;
begin
  restart := restart1;
end;

function escape: Boolean;
begin
  escape := stop1;
end;

procedure DefineTitle(s: string);
begin
  BlocksForm.TitleLabel.Caption := s;
end;

procedure writescreen(c, cmi, cma, nrun: integer; iden, mult, conv: boolean;
                      multinum, multi: integer);
var s: string;
begin
  with BlocksForm do
  begin
    LStatus.Caption := 'Gibbs sampling';
    LIteration.caption := 'number of iteration ';
    color.text := ' '+inttostr(c);
    IterationBounds.caption := '(1-'+inttostr(nrun)+')';

    if iden then s:='identified model      ' else s:='non-identified model';
    LIdent.Caption:=s;

    if mult then sequence.text := inttostr(multinum);
    if conv then s:='Convergence is assumed'
      else s:='Pre-convergence runs';
    LMinimal.Caption:=s;
  end;
  with BlocksForm.BRestart do Enabled:=conv; // 80
  with BlocksForm.BStop do Enabled:= true; // not conv;

 Application.ProcessMessages;
end; (* writescreen *)

procedure SayResults1;
begin
  with BlocksForm do begin
    LStatus.Caption := 'preparation of output';
    LIdent.Caption := 'calculating results';
    LMinimal.Caption := '';
   end;
  with BlocksForm.BRestart do Enabled:=false;
  with BlocksForm.BStop do Enabled:=true;
 Application.ProcessMessages;
end;

procedure SayResults2;
begin
  with BlocksForm do begin
    LStatus.Caption := 'preparation of output';
    LIdent.Caption := 'calculating separated classes';
    LMinimal.Caption := '';
   end;
  with BlocksForm.BRestart do Enabled:=false;
  with BlocksForm.BStop do Enabled:=true;
 Application.ProcessMessages;
end;

procedure ShowWorking(c: string);
begin
 with BlocksForm do begin
  LMinimal.Caption := LMinimal.Caption+c;
  if (length(LMinimal.Caption) > 80) then LMinimal.Caption := '';
 end;
 Application.ProcessMessages;
end;

procedure ShowXE(i,nn: integer; var x: coloring; d: integer);
var k: integer;
    s: string;
begin

  with BlocksForm do
  begin
    str(i:6,s);
    Iteration.Text:=s;
    for k:=1 to nn do
    begin
      BlocksForm.pc[k].visible:=true;
      BlocksForm.pc[k].color:=colorset[x[k]];
      BlocksForm.pc[k].caption:=inttostr(x[k]);
    end;
    ProgressBar.Position := d;
  end;
  Application.ProcessMessages;
end; (* ShowXE *)

begin (* unit BlockI *)
 stopped := false;
end.
